{% extends "operators/base.html" %}{% load i18n static %}
{% block title %}{% trans "Vehicles" %}{% endblock %}
{% block extrahead %}
<link rel="stylesheet" type="text/css" href="{% static 'datatables1/datatables.min.css' %}"/>
<script type="text/javascript" src="{% static 'datatables1/datatables.min.js' %}"></script>
{% endblock %}
{% block content %}
<!-- Modal to show QR -->
<div class="modal" id="pair_modal" tabindex="-1">
    <div class="modal-dialog modal-xl">
        <div class="modal-content">
            <input type="hidden" id="pair_vehicle_id">
            <div class="modal-header">
                <h5 class="modal-title">
                    {% trans "Pair in-vehicle device" %} -
                    <a id="pair_plate_nr"></a>
                    <a id="pair_car_model"></a>
                </h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                <div id="pair_warning" class="alert alert-warning">
                    {% blocktrans %}You're attempting to generate a QR code to pair the in-vehicle device with the cloud system.{% endblocktrans %}<br>
                    {% blocktrans %}Warning: if you generate a new QR code, the device won't be able to connect to the cloud until the new QR code has been scanned.{% endblocktrans %}
                </div>
                <div id="pair_loading" class="text-center">
                    <i class="fas fa-cog fa-spin fa-4x"></i>
                </div>
                <div id="pair_show_qr" class="text-center">
                    <div class="row">
                        <div class="col-md-6">
                            <div class="page-header">
                                <h2>Passo 1: scarica e installa MoveAid Companion App</h2>
                            </div>
                            <img src="{{ download_app_qr }}" alt="">
                        </div>
                        <div class="col-md-6">
                            <div class="page-header">
                                <h2>Passo 2: apri la app e scansiona questo QR</h2>
                            </div>
                            <img src="" alt="{% trans 'An error occurred' %}" id="pair_qr">
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">{% trans "Back" %}</button>
                <button type="button" class="btn btn-primary" id="pair_submit">{% trans "Generate QR code" %}</button>
            </div>
        </div>
    </div>
</div>


<div class="page-header row mb-4">
    <div class="col-lg-8">
        <h1>{% trans "Vehicles" %}</h1>
    </div>
    <div class="col-lg-4 text-end">
        <a class="btn btn-lg btn-success" href="{% url 'operators:new-vehicle' %}">
            <i class="fas fa-plus"></i>
            &nbsp; {% trans "Add vehicle" %}
        </a>
    </div>
</div>

<table id="table" class="table table-striped text-center">
    <thead>
        <tr>
            <th>{% trans "Owner" %}</th>
            <th>{% trans "Plate number" %}</th>
            <th>{% trans "Model" %}</th>
            <th>{% trans "Active" %}</th>
            <th>{% trans "Wheelchair" %}</th>
            <th>{% trans "Actions" %}</th>
        </tr>
    </thead>
    <tbody>
        {% for o in object_list %}
        <tr>
            <td>{{ o.owner.name }}</td>
            <td>{{ o.plate_number }}</td>
            <td>{{ o.car_model }}</td>
            <td>
                <i class="fas {% if o.active %}fa-check-circle text-success{% else %}fa-times text-danger{% endif %}" aria-hidden="true"></i>
            </td>
            <td>
                <i class="fas {% if o.wheelchair %}fa-check-circle text-success{% else %}fa-times text-danger{% endif %}" aria-hidden="true"></i>
            </td>
            <td>
                <a href="#" class="btn btn-lg btn-info pairbtn" data-vehicle-id="{{ o.pk }}" data-car-model="{{ o.car_model }}" data-plate-nr="{{ o.plate_number }}">
                    <i class="fas fa-qrcode"></i>
                </a>
                <a href="{% url 'operators:edit-vehicle' pk=o.pk %}" class="btn btn-lg btn-primary">
                    <i class="fas fa-edit"></i>
                </a>
                <a href="{% url 'operators:delete-vehicle' pk=o.pk %}" class="btn btn-lg btn-danger">
                    <i class="fas fa-trash"></i>
                </a>
            </td>
        </tr>
        {% endfor %}
    </tbody>
</table>

<script type="text/javascript">
    function launchPair() {
        $("#pair_vehicle_id").val($(this).attr("data-vehicle-id"));
        $("#pair_car_model").text($(this).attr("data-car-model"));
        $("#pair_plate_nr").text($(this).attr("data-plate-nr"));
        $("#pair_modal").modal("show");
        $("#pair_warning").show();
        $("#pair_submit").show();
        $("#pair_loading").hide();
        $("#pair_show_qr").hide();
    }

    $(document).ready(function() {
        $("#table").dataTable({
            language: {url: "{% static 'datatables1/i18n/'|add:LANGUAGE_CODE|add:"_"|add:LANGUAGE_CODE|add:'.json' %}"}
        });
        $(".pairbtn").each(function () {
            $(this).click(launchPair);
        });
        $("#pair_submit").click(function () {
            $("#pair_warning").hide();
            $("#pair_loading").show();
            $(this).hide();
            $.post({
                url: "{% url 'operators:pair-vehicle' %}",
                data: {"csrfmiddlewaretoken": "{{ csrf_token }}", "pk": $("#pair_vehicle_id").val()},
                success: function (data) {
                    $("#pair_loading").hide();
                    $("#pair_qr").attr("src", data);
                    $("#pair_show_qr").show();
                },
                dataType: "text"
            });
        });
    });
</script>

{% endblock %}